unit frm_breackout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, MPlayer,acercade;

type
  Tform1 = class(TForm)
    Timer1: TTimer;
    Imgpelota: TImage;
    imgbarra: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    mnuJuego: TMenuItem;
    smnuNuevo: TMenuItem;
    smnuSalir: TMenuItem;
    mnuinstrucc: TMenuItem;
    mnuACercade1: TMenuItem;
    media: TMediaPlayer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
    procedure smnuSalirClick(Sender: TObject);
    procedure smnuNuevoClick(Sender: TObject);
    procedure mnuinstruccClick(Sender: TObject);
    procedure mnuACercade1Click(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  form1: Tform1;

implementation

uses instrucciones;
const
tamanoX=20;
tamanoY=20;
izq=-1;
der=1;
arr=-1;
aba=1;
incrementoraqx=25;


var
intpelotax,intpelotay:integer;
IntDirX,IntDirY:integer;
velo,puntos,posi,vidas:integer;
ve,pun,vi:string;
{$R *.DFM}

procedure Tform1.FormCreate(Sender: TObject);
begin
// aparece en lugares direfentes la pelota
timer1.enabled:=false;
imgbarra.top:=form1.clientHeight-imgbarra.Height-5;
imgbarra.left:=form1.clientHeight div 2;
randomize;
intpelotax:=random(form1.width-imgpelota.width);
intpelotay:=random(form1.height div 2);
imgpelota.top:=intpelotay;
imgpelota.left:=intpelotax;
puntos:=0; vidas:=3;
label2.caption:='Vidas='+inttostr(vidas);

// inicializar el valor correcto de posi  =posicion de la raqueta
posi:=(form1.clientwidth-imgbarra.width) div 2 ;

// movim izq o derecho de la pelota
if (random(10) mod 2)=0 then   IntDirx:=izq  else  IntDirx:=der;

// que la peota siempre inicie hacia arriba para darle mas oportunidad de
//adaptarse al jugador
if (random(10) mod 2)=0 then   IntDiry:=arr else  IntDiry:=arr;
end;
procedure Tform1.Timer1Timer(Sender: TObject);
begin
// cheacar que pegue en el lado izq
if imgpelota.left<=1 then intdirX:=der;
// cheacar que pegue arriba
if imgpelota.top<=1 then intdiry:=aba;
// cheacar que pegue en el lado derecho
if imgpelota.left+imgpelota.width>=(form1.clientWidth-tamanoy)  then
intdirX:=izq;
// cheacar que pegue abajo de la barra  = pierda
if (imgpelota.top+imgpelota.height>form1.clientheight)  then
begin
intdiry:=arr;
imgpelota.top:=1;
dec(vidas,1);
str(vidas,vi);
label2.caption:='Vidas='+vi;
if vidas=0 then
begin
 //  timer1.enabled:=false;
 if puntos=0 then pun:='0';
 label1.caption:='Puntos Finales='+pun;
 timer1.enabled:=false;
 end;
  //sonido pierde pelota
 media.filename:='pierde.wav';
 media.devicetype:=dtAutoSelect;
 media.Open;
 media.play;
end;


// checar si pega en la barra
 if (imgpelota.left+imgpelota.width>=imgbarra.left) and
  (imgpelota.left<=imgbarra.left+imgbarra.width) then
  begin
  if   (imgpelota.top+imgpelota.height)>=(imgbarra.Top)  then
   begin
   intdiry:=arr;
   inc(puntos);
   // sonido   de golpe a pelota
      media.filename:='golpe.wav';
      media.devicetype:=dtAutoSelect;
      media.Open;
      media.play;
   // por cada 50 puntos se regala una vida al usuario
   if (puntos mod 50)=0 then
   begin

        //sonido pierde pelota
        media.filename:='50puntos.wav';
        media.devicetype:=dtAutoSelect;
        media.Open;
        media.play;
   end;

         // por cada 3 golpes buenos se decrementa el tamao de la barra (raqueta)
   if (puntos mod 3)=0 then
   imgbarra.width:=  imgbarra.width-10;
   // si la barra es demasiado pequea acelerar la pelota hasta llegar
   // velocidad maxima de 80
   if imgbarra.width<=90 then
   begin
    imgbarra.width:=90;
    if (puntos mod 5)=0 then
    begin
     timer1.interval:= timer1.interval-5;
     // Establece velocidad maxima de 80  para  la caida de la pelota
     if timer1.interval<=30 then timer1.interval:=30;
     velo:= 110-timer1.interval;
     str(velo,ve);
     label3.caption:='Velocidad=['+ve+']';
    end;
   end;
   pun:=inttostr(puntos);
   label1.caption:='Puntos='+pun;
   end;
 end;

  // posicionando la pelota (efecto movimiento)
 imgpelota.left:=imgpelota.left+(tamanoX*Intdirx);
 imgpelota.top:=imgpelota.top+(tamanoY*Intdiry);


end;

procedure Tform1.FormKeyPress(Sender: TObject; var Key: Char);
begin
// g izquierda  y       h=derecha

if key='g' then
begin
// validando que la barra (raqueta) no salga del margen izquierdo
  dec(posi,40);
  if posi<=1 then posi:=1;
  imgbarra.left:= posi;
end;
  if key='h' then
begin
// validando que la barra (raqueta) no salga del margen derecho
   inc(posi,40);
  if posi>=(form1.clientwidth-imgbarra.width) then
   posi:=form1.clientwidth-imgbarra.width;
   imgbarra.left:=posi;
end;

end;

procedure Tform1.FormResize(Sender: TObject);
begin
//height =Alto
//Width = Ancho
imgbarra.top:=form1.clientHeight-imgbarra.height;
imgbarra.left:=(form1.clientwidth-imgbarra.width) div 2;
end;

procedure Tform1.smnuSalirClick(Sender: TObject);
begin
// salir del juego
form1.Close;
end;

procedure Tform1.smnuNuevoClick(Sender: TObject);
begin
// un nuevo juego
 timer1.enabled:=false;
 puntos:=0;
 vidas:=3;
 label1.caption:='Puntos=0';
 timer1.enabled:=true;
 label2.caption:='Vidas='+inttostr(vidas);
end;

procedure Tform1.mnuinstruccClick(Sender: TObject);
begin
// abre dialogo instrucciones
instrucc.showmodal;
end;

procedure Tform1.mnuACercade1Click(Sender: TObject);
begin
// abre dialogo a cerca de..
sobre.showmodal;
end;

procedure Tform1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
label1.top:=0;
label1.left:=(form1.ClientWidth)- 120;
end;

end.
